VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmMain 
   Caption         =   "MegaSquirt COM example"
   ClientHeight    =   6996
   ClientLeft      =   48
   ClientTop       =   432
   ClientWidth     =   6852
   LinkTopic       =   "Form1"
   ScaleHeight     =   6996
   ScaleWidth      =   6852
   StartUpPosition =   3  'Windows Default
   Begin RichTextLib.RichTextBox rtbText 
      Height          =   1572
      Left            =   240
      TabIndex        =   15
      Top             =   2760
      Width           =   2892
      _ExtentX        =   5101
      _ExtentY        =   2773
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmMain.frx":0000
   End
   Begin VB.CommandButton cmdModifyTable 
      Caption         =   "Modify Table"
      Height          =   492
      Left            =   3120
      TabIndex        =   14
      Top             =   2040
      Width           =   1452
   End
   Begin VB.CommandButton cmdVersion 
      Caption         =   "Get Version"
      Height          =   492
      Left            =   1680
      TabIndex        =   13
      Top             =   2040
      Width           =   1332
   End
   Begin VB.Frame Frame3 
      Caption         =   "Select Variable"
      Height          =   1692
      Left            =   4680
      TabIndex        =   10
      Top             =   240
      Width           =   1932
      Begin VB.CommandButton cmdVariables 
         Caption         =   "Get Variable"
         Height          =   372
         Left            =   240
         TabIndex        =   12
         Top             =   1080
         Width           =   1452
      End
      Begin VB.ComboBox cboVariable 
         Height          =   288
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   11
         Top             =   480
         Width           =   1452
      End
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Text"
      Height          =   492
      Left            =   5280
      TabIndex        =   9
      Top             =   2040
      Width           =   1332
   End
   Begin VB.Frame Frame2 
      Caption         =   "Select Table"
      Height          =   1692
      Left            =   2880
      TabIndex        =   6
      Top             =   240
      Width           =   1692
      Begin VB.CommandButton cmdTable 
         Caption         =   "Get Table"
         Height          =   372
         Left            =   120
         TabIndex        =   8
         Top             =   1080
         Width           =   1452
      End
      Begin VB.ComboBox cboTable 
         Height          =   288
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   7
         Top             =   480
         Width           =   1452
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "COM Port"
      Height          =   1692
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   2532
      Begin VB.ComboBox cboCOMPort 
         Height          =   288
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   720
         Width           =   1092
      End
      Begin VB.CommandButton cmdTestPort 
         Caption         =   "Test Port"
         Height          =   372
         Left            =   1320
         TabIndex        =   2
         Top             =   720
         Width           =   972
      End
      Begin VB.Label lblTestMsg 
         Alignment       =   2  'Center
         BeginProperty Font 
            Name            =   "Arial"
            Size            =   10.2
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   252
         Left            =   240
         TabIndex        =   5
         Top             =   1320
         Width           =   2052
      End
      Begin VB.Label Label1 
         Caption         =   "Select port"
         Height          =   252
         Left            =   120
         TabIndex        =   4
         Top             =   480
         Width           =   1092
      End
   End
   Begin VB.CommandButton cmdSignature 
      Caption         =   "Get Signature"
      Height          =   492
      Left            =   240
      TabIndex        =   0
      Top             =   2040
      Width           =   1332
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   3960
      Top             =   3240
      _ExtentX        =   995
      _ExtentY        =   995
      _Version        =   393216
      DTREnable       =   -1  'True
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim labelBackColor As Long

Private Sub TestPort()
' Test the selected port by using the generic ConnectPort
' routine
    Dim Connected As Boolean
    Dim ErrDescription As String

    Connected = ConnectPort(MSComm1, cboCOMPort.ListIndex + 1, ErrDescription)

    ' Write message and change color depending on connect result
    If Connected Then
        lblTestMsg.BackColor = vbGreen
        lblTestMsg.Caption = "Success"
    Else
        lblTestMsg.BackColor = vbRed
        lblTestMsg.Caption = "No Connection"
        rtbText.SelText = "ERROR: No Connection  " & vbCrLf
        If Len(ErrDescription) > 0 Then
            rtbText.SelText = ErrDescription & vbCrLf
        End If
    End If

End Sub


Private Sub cboCOMPort_Click()
' If port is changed close port and reset the label

    If MSComm1.PortOpen = True Then
        MSComm1.PortOpen = False
        lblTestMsg.BackColor = labelBackColor
        lblTestMsg.Caption = ""
    End If
End Sub

Private Sub cmdClear_Click()
' Clear the text on the Rich Text box
    rtbText.Text = ""
End Sub

Private Sub cmdVariables_Click()
' Get variables returned with the cmd 'A' and display the selected one
' These are not all the variables.
' Use 'R' to return more variables
    Dim Data As Variant

    On Error GoTo VariableError

    ' Set up the description of the variables
    ' This is usually only done at start up
    ' This is here only in case the table changes during debug
    setVariable

    ' Open port if not already open
    If MSComm1.PortOpen = False Then
        TestPort
    End If

    ' Get the Data for the variables
    GetVariables MSComm1, Data

    ' Write the selected variable
    ' cboVariable.ListIndex is the location of the
    ' selected variable in the byte array 'Data'
    rtbText.SelText = cboVariable.List(cboVariable.ListIndex) & " = " & _
                      Format$(Data(cboVariable.ListIndex)) & _
                      " (raw unscaled data)" & vbCrLf

    Exit Sub
VariableError:
    Debug.Print "sub cmdVariables_click Error: "; Err.Description
End Sub
Private Sub cmdTable_Click()
' Get the table selected by user
    Dim Data As Variant

    ' Set up the table constant
    ' This is here only in case the table changes during debug
    setTable

    ' Open port if not already open
    If MSComm1.PortOpen = False Then
        TestPort
    End If

    If lblTestMsg.BackColor = vbGreen Then
        ' Get the page for the table and the page data
        GetTable MSComm1, Data, cboTable.ListIndex

        ' Write the table from the page 'Data'
        MakeTable rtbText, Data, cboTable.ListIndex
    End If

End Sub

Private Sub cmdTestPort_Click()
    TestPort
End Sub

Private Sub cmdSignature_Click()
' Get the string for Signature
    Dim Msg As String
    Dim ErrDescription As String

    If MSComm1.PortOpen = False Then
        TestPort
    End If

    Msg = GetSignature(MSComm1, ErrDescription)

    ' Write message
    rtbText.SelText = Msg & vbCrLf

    ' Write error if error
    If Len(ErrDescription) > 0 Then
        rtbText.SelText = ErrDescription & vbCrLf
    End If

End Sub

Private Sub cmdVersion_Click()
' Using a generic string function get the MS firmware version
    Dim Msg As String
    Dim ErrDescription As String

    If MSComm1.PortOpen = False Then
        TestPort
    End If

    Msg = GetString(MSComm1, "T", ErrDescription)

    ' Write message to rich text box
    rtbText.SelText = Msg & vbCrLf

    ' Write error if error
    If Len(ErrDescription) > 0 Then
        rtbText.SelText = ErrDescription & vbCrLf
    End If


End Sub

Private Sub cmdModifyTable_Click()
' Modify the first byte of the table
' The first byte is the lower left value
    Dim Data As Variant


    ' Open port if not already open
    If MSComm1.PortOpen = False Then
        TestPort
    End If

    ' Change the page for the table and the set the table value
    ChangeTable MSComm1, 99, cboTable.ListIndex

End Sub

Private Sub Form_Load()
    Dim i As Long

    Form_Resize
    setTable
    setVariable

    labelBackColor = lblTestMsg.BackColor

    ' Fill COM port selection combo box
    For i = 1 To 4
        cboCOMPort.AddItem " COM" & Str$(i)
    Next i
    cboCOMPort.ListIndex = 0

    ' Fill the table selection box
    cboTable.AddItem "VE table 1"
    cboTable.AddItem "VE table 2"
    cboTable.AddItem "VE table 3"
    cboTable.AddItem "AFR table 1"
    cboTable.AddItem "AFR table 2"
    cboTable.AddItem "IGN table 1"
    cboTable.ListIndex = 0

    ' Fill the Variable selection combo box
    setVariable
    For i = 0 To UBound(VariableIndex)
        Me.cboVariable.AddItem VariableIndex(i)
    Next i
    cboVariable.ListIndex = 0

End Sub

Private Sub Form_Resize()
    On Error Resume Next
    rtbText.Move 50, 2700, Me.ScaleWidth - 2 - 100, Me.ScaleHeight - 2 - 2750
End Sub


